/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 22.12.2009
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATtiny2313
Clock frequency     : 8,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 32
*****************************************************/

#include <tiny2313.h>

#define BYTE    unsigned char
#define SET_B(x) |= (1<<x)  
#define CLR_B(x) &=~(1<<x) 
#define INV_B(x) ^=(1<<x) 

// 1 Wire Bus functions
#asm
   .equ __w1_port=0x12 ;PORTD         //  D bit6   1wire 11  
   .equ __w1_bit=6                         
#endasm
#include <1wire.h>

// DS1820 Temperature Sensor functions
#include <ds1820.h>
#include <delay.h>
// maximum number of DS1820 devices
// connected to the 1 Wire bus
#define MAX_DS1820 6		     // -  6 (    ) 	
// number of DS1820 devices
// connected to the 1 Wire bus
                unsigned char ds1820_devices;
// DS1820 devices ROM code storage area,
// 9 bytes are used for each device
// (see the w1_search function description in the help)
                unsigned char ds1820_rom_codes[MAX_DS1820][9];  //     

// Declare your global variables here

BYTE byDisplay[3] = {0,0,0};             //  ,    

BYTE byCharacter[14] = { 		//        	
                         63,  //0
                          6,  //1
                         91,  //2
                         79,  //3
                        102,  //4
                        109,  //5
                        125,  //6
                          7,  //7
                        127,  //8
                        111,  //9
                         64,  //-
                         99,  //  
                         00,  // " "
                         94   //d
                       };
                        
                        
                       /*\
                         
                        a
                        -
                     f| g |b
                        -
                     e| d |c h
                        -    .                            
                       \*/
                        
                        
 BYTE k1,k2,znak; 			//k1,k2     , znak- , temp-  
 int temp;
              	


//   
void dannie(BYTE q0,BYTE q1,BYTE q2)
{
 byDisplay[0]=q0;
 byDisplay[1]=q1;
 byDisplay[2]=q2;
 
}

//   , b1,b2- 
void showdisplay(BYTE b1,BYTE b2)
{
BYTE b3,b4,i; 
for (b3=0; b3<b1; b3++)
for (b4=0; b4<b2; b4++)
        {
		for (i=0; i<3; i++)
		                        {
		 			 PORTB = byCharacter[byDisplay[i]];
                                         
                                        // PORTB = ~byCharacter[byDisplay[i]];      
                                         
                                         //PORTB = byDisplay[i]
                                         
                                           
                                         PORTD CLR_B(i);
                		         delay_ms(5);
                		         PORTD SET_B(i);
                                           
                                           /*\					
					 PORTD SET_B(i);  //     
                		         delay(0,150);
                		         PORTD CLR_B(i);
                                           \*/
					}
		}
	
}






void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=In Func0=In 
// State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port D initialization
// Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0x3F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// Determine the number of DS1820 devices
// connected to the 1 Wire bus
//ds1820_devices=w1_search(0xf0,ds1820_rom_codes);

 
 /* detect how many DS1820/DS18S20 devices
   are connected to the 1 Wire bus */

dannie(8,8,8);						//   888 -  
showdisplay(20,20); 

ds1820_devices=w1_search(0xf0,ds1820_rom_codes);	//     

dannie(13,10,ds1820_devices);				//    d-ds1820_devices,  ds1820_devices-- 
showdisplay(10,20); 
k2=0;
while (1)
      {
      // Place your code here
   
if (ds1820_devices > 0)					//    
     {
                for (k1=0;k1<ds1820_devices;k1++)
                {
                        
                        temp= ds1820_temperature_10(&ds1820_rom_codes[k1][0]); //  temp  n- 
                        znak=0;  // "+"
                                if (temp<0)
                                {
                                znak=1; // "-"
                                temp=-temp;
                                }; 
                               
                 temp=temp/10;				//     ,    
                        if (k2<5) k2++;
                        if ((ds1820_devices > 1) & (k2 > 2))	//k2   ,      2       	
                        {
                        dannie (10,k1+1,10);		//   -n-
                        showdisplay(10,10);     
                        dannie (12,12,12);		//  
                        showdisplay(1,30); 
                        }
      
                        if (znak < 1)			//     
                        { 
                         
                        if (temp < 10) dannie (12,temp,11);
                        if (temp > 9) dannie (temp/10,temp%10,11);     
                        if (temp >= 100) dannie (temp/100,(temp%100)/10,temp%10);
                        }
                        
                        if (znak > 0) 			//     
                        { 
                        if (temp < 10) dannie (10,temp,11);
                        if (temp > 9) dannie (10,temp/10,temp%10);     
                        }      
                
                if (k2>2) showdisplay(10,20);
                };
                
        } 
if (ds1820_devices == 0) 				//     ---            
                {
                dannie(10,10,10);
                showdisplay(10,20);
                } 
 
        }
 
}
//           
//         
